=== c++/CMakeLists.txt ===

add_subdirectory(include)
add_subdirectory(lib)
add_subdirectory(tests)
add_subdirectory(examples)
