=== c++/include/CMakeLists.txt ===
add_subdirectory(gensio)
