=== glib/swig/CMakeLists.txt ===
include(UseSWIG)
if(PYTHONLIBS_FOUND)
  add_subdirectory(python)
endif()
