=== debian/changelog ===
gensio (2.3.5-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:17:21 +0000

gensio (2.3.5-1build1) jammy; urgency=medium

  * No-change rebuild against libssl3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 23:31:40 +0000

gensio (2.3.5-1) unstable; urgency=medium

  * new upstream version 2.3.5

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sat, 06 Feb 2021 12:00:53 +0100
