=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --with python3,autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --with-tcp-wrappers \
		--with-openssl \
		--with-avahi \
		--with-swig \
		--with-python

override_dh_auto_clean:
	dh_auto_clean
	rm -rf tests/__pycache__

# disable the upstream tests, they depend on an out-of-tree kernel module
override_dh_auto_test:
	true
